#include <eikapp.h>
#include <e32base.h>
#include <sdlapp.h>
#include <stdio.h>
#include <BAUTILS.H>
#include <eikenv.h>
#include <hal.h>
#include <hal_data.h>

#if defined (EPOC_AS_APP) && !defined (UIQ3) && !defined(S60V3)
#include "ECompXL.h"
#endif

class CShadowWApp : public CSDLApp {
public:
	CShadowWApp();
	~CShadowWApp();

	TUid AppDllUid() const;
#if defined (EPOC_AS_APP)  && !defined (UIQ3) && !defined(S60V3)
	TECompXL    iECompXL;
#endif

#if defined (UIQ3) 
	/**
	 * Returns the resource id to be used to declare the views supported by this UIQ3 app
	 * @return TInt, resource id
	 */
	TInt ViewResourceId();
#endif

};


#ifdef EPOC_AS_APP

// this function is called automatically by the SymbianOS to deliver the new CApaApplication object
#if !defined (UIQ3) && !defined(S60V3)
EXPORT_C 
#endif
CApaApplication* NewApplication() {
	// Return pointer to newly created CQMApp
	return new CShadowWApp;
}

#if defined (UIQ3) || defined (__SERIES60_30__)
#include <eikstart.h>
// E32Main() contains the program's start up code, the entry point for an EXE.
GLDEF_C TInt E32Main() {
 	return EikStart::RunApplication(NewApplication);
}
#endif

#endif // EPOC_AS_APP

#if !defined (UIQ3) && !defined (__SERIES60_30__)
GLDEF_C  TInt E32Dll(TDllReason) {
	return KErrNone;
}
#endif
CShadowWApp::CShadowWApp() {
}

CShadowWApp::~CShadowWApp() {
}

/**
 *   Responsible for returning the unique UID of this application
 * @return unique UID for this application in a TUid
 **/
TUid CShadowWApp::AppDllUid() const {
	return TUid::Uid(0xA30033A6);
}
#if defined (UIQ3)
#include <ShadowW.rsg>
/**
 * Returns the resource id to be used to declare the views supported by this UIQ3 app
 * @return TInt, resource id
 */
TInt CShadowWApp::ViewResourceId() {
	return R_SDL_VIEW_UI_CONFIGURATIONS;
}
#endif



#include <string.h>
#include <stdarg.h>
extern "C" void puts_empty(const char* aStr)
{
/*	TPtrC8 ptr((const unsigned char*)aStr,strlen(aStr));
	TBuf<256> line;
	line.Copy(ptr);
	line.PtrZ();
	User::InfoPrint(line);

/*	FILE* file = fopen("d:\\log.txt","a+b");
	if(file != NULL)
	{
		fwrite(aStr,strlen(aStr),1,file);
		fclose(file);
	}*/

//	RDebug::Print(line);
}

extern "C" int	printf_empty		(const char * aStr, ...)
{
	char buf[1024];
	va_list va;

	va_start(va, aStr);
	vsprintf(buf, aStr, va);
	va_end(va);
	
/*	TPtrC8 ptr((const unsigned char*)buf,strlen(buf));
	TBuf<256> line;
	line.PtrZ();
	line.Copy(ptr);
//	RDebug::Print(line);
	User::InfoPrint(line);*/
#ifdef __WINS__
	FILE* file = fopen("c:\\log.txt","a+b");
#else
	FILE* file = NULL;//fopen("d:\\log.txt","a+b");
#endif
	if(file != NULL)
	{
		fwrite(buf,strlen(buf),1,file);
		fclose(file);
	}
	return 0;
}

extern "C" char* DataDrive()
{
	if(BaflUtils::FolderExists(CEikonEnv::Static()->FsSession(), _L("E:\\ShadowWarrior")))
		return "e:\\ShadowWarrior";

	if(BaflUtils::FolderExists(CEikonEnv::Static()->FsSession(), _L("D:\\ShadowWarrior")))
		return "d:\\ShadowWarrior";
#ifdef UIQ3
	return "c:\\shared\\shadoww";
#else
	return "c:\\data\\shadoww";
#endif
}

//
// getsysmemsize() -- gets the amount of system memory in the machine
//
extern "C" void OSD_Printf(const char *fmt, ...);

extern "C" unsigned int Bgetsysmemsize(void)
{	
	// At least 16 mb should be available I hope.this will allocate 10 mb cache..
	// Check from 32 mb and downwards
	TInt memsize = 64768000;
	void* memory = User::Alloc(memsize);

	while(memory == NULL)
	{
		memsize -=1024000;
		memory = User::Alloc(memsize);
	}
	User::Free(memory);
	return memsize;
}


/////////////////////////////////////////////////////////////////////////////////////////////////


